package sun.java2d.loops;

import sun.java2d.pipe.SpanIterator;
import sun.java2d.SurfaceData;
import sun.java2d.SunGraphics2D;

public class FillSpans extends GraphicsPrimitive
{
    public static final String methodSignature;
    public static final int primTypeID;
    
    public static FillSpans locate(SurfaceType surfaceType, CompositeType compositeType, SurfaceType surfaceType2) {
        return (FillSpans)GraphicsPrimitiveMgr.locate(FillSpans.primTypeID, surfaceType, compositeType, surfaceType2);
    }
    
    protected FillSpans(SurfaceType surfaceType, CompositeType compositeType, SurfaceType surfaceType2) {
        super(FillSpans.methodSignature, FillSpans.primTypeID, surfaceType, compositeType, surfaceType2);
    }
    
    public FillSpans(long n, SurfaceType surfaceType, CompositeType compositeType, SurfaceType surfaceType2) {
        super(n, FillSpans.methodSignature, FillSpans.primTypeID, surfaceType, compositeType, surfaceType2);
    }
    
    private native void FillSpans(SunGraphics2D p0, SurfaceData p1, int p2, long p3, SpanIterator p4);
    
    public void FillSpans(SunGraphics2D sunGraphics2D, SurfaceData surfaceData, SpanIterator spanIterator) {
        this.FillSpans(sunGraphics2D, surfaceData, sunGraphics2D.pixel, spanIterator.getNativeIterator(), spanIterator);
    }
    
    @Override
    public GraphicsPrimitive makePrimitive(SurfaceType obj, CompositeType obj2, SurfaceType surfaceType) {
        throw new InternalError("FillSpans not implemented for " + obj + " with " + obj2);
    }
    
    @Override
    public GraphicsPrimitive traceWrap() {
        return new FillSpans.TraceFillSpans(this);
    }
    
    static {
        methodSignature = "FillSpans(...)".toString();
        primTypeID = GraphicsPrimitive.makePrimTypeID();
    }
    
    private static class TraceFillSpans extends FillSpans
    {
        FillSpans target;
        
        public TraceFillSpans(FillSpans target) {
            super(target.getSourceType(), target.getCompositeType(), target.getDestType());
            this.target = target;
        }
        
        @Override
        public GraphicsPrimitive traceWrap() {
            return this;
        }
        
        @Override
        public void FillSpans(SunGraphics2D sunGraphics2D, SurfaceData surfaceData, SpanIterator spanIterator) {
            GraphicsPrimitive.tracePrimitive(this.target);
            this.target.FillSpans(sunGraphics2D, surfaceData, spanIterator);
        }
    }
}
